#!/bin/bash

ssh R1 << 'EOF'

set -e

ip netns del ns2 2>/dev/null || true
ip link del veth0 2>/dev/null || true
ip link del veth1 2>/dev/null || true


ip netns add ns2

ip link add veth1 type veth peer name veth1-ns
ip link add veth0 type veth peer name veth0-ns

ip link set veth1-ns netns ns2
ip link set veth0-ns netns ns2

ip link set veth1 up
ip link set veth0 up


ip netns exec ns2 ip link set lo up
ip netns exec ns2 ip link set veth1-ns name veth1
ip netns exec ns2 ip link set veth0-ns name veth0
ip netns exec ns2 ip link set veth1 up
ip netns exec ns2 ip link set veth0 up

ip addr add 192.168.1.1/24 dev veth1
ip netns exec ns2 ip addr add 192.168.1.2/24 dev veth1

ip addr add 192.168.0.1/24 dev veth0
ip netns exec ns2 ip addr add 192.168.0.2/24 dev veth0

ip netns exec ns2  echo 1 > /proc/sys/net/ipv4/ip_forward

ip netns exec ns2 bash -c cat > /root/nat-r2.nft << 'ENDNAT'

flush ruleset

table ip nat {
	chain masq {
		type nat hook postrouting priority 100;
		oifname "veth0" counter masquerade
	}
}
ENDNAT

nft -f /root/nat-r2.nft

ip netns exec ns2 ip route add 10.0.0.0/24 via 192.168.1.1
ip netns exec ns2 ip route add default via 192.168.0.1

ip route delete default || true
ip route add default via 192.168.1.1

echo 100 custom >> /etc/iproute2/rt_tables
ip rule add iif veth0 table custom
ip route add default via 172.21.1.1 table custom

EOF
