#!/bin/bash

ssh H1 << 'EOF'
set -e

ip addr flush dev eth0
ip addr add 10.0.0.2/24 dev eth0
ip link set eth0 up

ip route del default 2>/dev/null || true
ip route add default via 10.0.0.254

EOF

ssh R1 << 'EOF'
set -e

ip netns del ns2 2>/dev/null || true
ip link del br0 2>/dev/null || true
ip link del br1 2>/dev/null || true
ip link del veth1 2>/dev/null || true
ip link del veth0 2>/dev/null || true

nft flush ruleset 2>/dev/null || true

ip link add br0 type bridge
ip link set br0 up

ip link add br1 type bridge
ip link set br1 up


ip link add veth0 type veth peer name veth0-ns
ip link add veth1 type veth peer name veth1-ns

ip netns add ns2
ip link set veth0-ns netns ns2
ip link set veth1-ns netns ns2

ip link set eth0 up
ip link set eth0 master br0

ip link set eth1 up
ip link set eth1 master br1

ip link set veth0 up
ip link set veth0 master br0

ip link set veth1 up
ip link set veth1 master br1

ip netns exec ns2 ip link set veth0-ns name eth0
ip netns exec ns2 ip link set eth0 up

ip netns exec ns2 ip link set veth1-ns name eth1
ip netns exec ns2 ip link set eth1 up

ip addr add 172.21.1.100/24 dev br0
ip addr add 10.0.0.254/24 dev br1

ip netns exec ns2  echo 1 > /proc/sys/net/ipv4/ip_forward

ip route del default via 172.21.1.1 dev br0 2>/dev/null || true
ip route add default via 172.21.1.1 dev br0

ip netns exec ns2 bash -c cat > /root/nat-r2.nft << 'ENDNFT'
#!/usr/sbin/nft -f
flush ruleset

table ip nat {
    chain masq {
        type nat hook postrouting priority 100;
        oifname "br0" counter masquerade
    }
}
ENDNFT

nft -f /root/nat-r2.nft
EOF