#!/bin/bash

ssh -tt H1 << 'EOF'
set -e

ip addr flush dev eth0
ip addr add 10.0.0.2/24 dev eth0
ip link set eth0 up

ip route del default 2>/dev/null || true
ip route add default via 10.0.0.254

EOF

ssh -tt R1 << 'EOF'
set -e

ip netns add ns2
ip netns add ns3

ip link add br0 type bridge
ip link set br0 up

ip link add br1 type bridge
ip link set br1 up

ip addr add 172.21.1.100/24 dev br0
ip addr add 10.0.0.254/24 dev br1

ip link set eth1 up
ip link set eth1 master br1

ip link set eth0 up
ip link set eth0 master br0

ip link add veth0-r1 type veth peer name veth0-ns2
ip link add veth1-r1 type veth peer name veth0-ns3
ip link add veth1-ns2 type veth peer name veth1-ns3

ip link set veth0-r1 up
ip link set veth0-r1 master br0

ip link set veth1-r1 up
ip link set veth1-r1 master br1

ip link set veth0-ns2 netns ns2
ip link set veth1-ns2 netns ns2

ip link set veth0-ns3 netns ns3
ip link set veth1-ns3 netns ns3

# -----------------------------------------------

ip netns exec ns3 ip link set veth0-ns3 name eth0
ip netns exec ns3 ip link set veth1-ns3 name eth1

ip netns exec ns3 ip link set eth0 up
ip netns exec ns3 ip link set eth1 up

ip netns exec ns3 ip addr add 192.168.32.2/24 dev eth1
ip netns exec ns3 ip addr add 10.0.0.254/24 dev eth0

ip netns exec ns3 ip route add default via 192.168.32.1 dev eth1

# ------------------------------------------------

ip netns exec ns2 ip link set veth0-ns2 name eth0
ip netns exec ns2 ip link set veth1-ns2 name eth1

ip netns exec ns2 ip link set eth0 up
ip netns exec ns2 ip link set eth1 up

ip netns exec ns2 ip addr add 192.168.32.1/24 dev eth1
ip netns exec ns2 ip addr add 172.21.1.100/24 dev eth0

ip netns exec ns2 ip route add 10.0.0.0/24 via 192.168.32.2 dev eth1
ip netns exec ns2 ip route add default via 172.21.1.1 dev eth0

# --------------------------------------------------

ip netns exec ns2  echo 1 > /proc/sys/net/ipv4/ip_forward
ip netns exec ns3  echo 1 > /proc/sys/net/ipv4/ip_forward

ip netns exec ns2 bash -c cat > /root/nat-r2.nft << 'ENDNFT'
#!/usr/sbin/nft -f
flush ruleset

table ip nat {
    chain masq {
        type nat hook postrouting priority 100;
        oifname "br0" counter masquerade
    }
}
ENDNFT

nft -f /root/nat-r2.nft
EOF